import { EngineOptions } from '@alilc/lowcode-editor-core';
import { LowCodePluginManager, PluginPreference, TransformStage } from '@alilc/lowcode-designer';
import { Hotkey, Project, Skeleton, Setters, Material, Event } from '@alilc/lowcode-shell';
import './modules/live-editing';
import * as editorCabin from './modules/editor-cabin';
export * from './modules/editor-types';
export * from './modules/skeleton-types';
export * from './modules/designer-types';
export * from './modules/lowcode-types';
declare const plugins: LowCodePluginManager;
declare const hotkey: Hotkey;
declare const project: Project;
declare const skeleton: Skeleton;
declare const setters: Setters;
declare const material: Material;
declare const config: import("@alilc/lowcode-editor-core").EngineConfig;
declare const event: Event;
declare const logger: import("zen-logger/types").default;
declare const common: {
    utils: {
        isNodeSchema: typeof import("@alilc/lowcode-types").isNodeSchema;
        isFormEvent: typeof import("@alilc/lowcode-utils").isFormEvent;
        compatibleLegaoSchema: typeof import("@alilc/lowcode-utils").compatibleLegaoSchema;
        getNodeSchemaById: typeof import("@alilc/lowcode-utils").getNodeSchemaById;
        getConvertedExtraKey: typeof import("@alilc/lowcode-designer").getConvertedExtraKey;
        getOriginalExtraKey: typeof import("@alilc/lowcode-designer").getOriginalExtraKey;
    };
    objects: {
        TransformStage: typeof TransformStage;
    };
    editorCabin: typeof editorCabin;
    designerCabin: {
        SettingField: typeof import("@alilc/lowcode-designer").SettingField;
        isSettingField: typeof import("@alilc/lowcode-designer").isSettingField;
        dragon: import("@alilc/lowcode-shell").Dragon;
        TransformStage: typeof TransformStage;
        LiveEditing: typeof import("@alilc/lowcode-designer").LiveEditing;
        DragObjectType: typeof import("@alilc/lowcode-designer").DragObjectType;
        isDragNodeDataObject: typeof import("@alilc/lowcode-designer").isDragNodeDataObject;
        isNode: typeof import("@alilc/lowcode-designer").isNode;
    };
    skeletonCabin: any;
};
export { skeleton, plugins, project, setters, material, config, event, logger, hotkey, common, event as editor, };
export declare const isOpenSource = true;
export declare const __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED: {
    symbols: {
        projectSymbol: symbol;
        documentSymbol: symbol;
        nodeSymbol: symbol;
        skeletonSymbol: symbol;
        editorSymbol: symbol;
        designerSymbol: symbol;
        settingPropEntrySymbol: symbol;
        settingTopEntrySymbol: symbol;
    };
    classes: {
        Project: typeof Project;
        Skeleton: typeof Skeleton;
        DocumentModel: typeof import("@alilc/lowcode-shell").DocumentModel;
        Node: typeof import("@alilc/lowcode-shell").Node;
        NodeChildren: typeof import("@alilc/lowcode-shell").NodeChildren;
        History: typeof import("@alilc/lowcode-shell").History;
        SettingPropEntry: typeof import("@alilc/lowcode-shell").SettingPropEntry;
        SettingTopEntry: typeof import("@alilc/lowcode-shell").SettingTopEntry;
        InnerNode: typeof import("@alilc/lowcode-designer").Node;
        Selection: typeof import("@alilc/lowcode-shell").Selection;
    };
};
export declare const version: any;
export declare function init(container?: HTMLElement, options?: EngineOptions, pluginPreference?: PluginPreference): Promise<void>;
