"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
var _exportNames = {
  skeleton: true,
  plugins: true,
  project: true,
  setters: true,
  material: true,
  config: true,
  event: true,
  editor: true,
  logger: true,
  hotkey: true,
  common: true,
  isOpenSource: true,
  __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED: true,
  version: true,
  init: true
};
exports.hotkey = exports.event = exports.editor = exports.config = exports.common = exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = void 0;
exports.init = init;
exports.version = exports.skeleton = exports.setters = exports.project = exports.plugins = exports.material = exports.logger = exports.isOpenSource = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = require("react");

var _reactDom = require("react-dom");

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _lowcodeDesigner = require("@alilc/lowcode-designer");

var _lowcodeEditorSkeleton = require("@alilc/lowcode-editor-skeleton");

var _lowcodePluginOutlinePane = _interopRequireWildcard(require("@alilc/lowcode-plugin-outline-pane"));

var _lowcodePluginDesigner = _interopRequireDefault(require("@alilc/lowcode-plugin-designer"));

var _lowcodeShell = require("@alilc/lowcode-shell");

var _lowcodeUtils = require("@alilc/lowcode-utils");

require("./modules/live-editing");

var _utils = _interopRequireDefault(require("./modules/utils"));

var editorCabin = _interopRequireWildcard(require("./modules/editor-cabin"));

var _skeletonCabin = _interopRequireDefault(require("./modules/skeleton-cabin"));

var _designerCabin = _interopRequireDefault(require("./modules/designer-cabin"));

var _classes = _interopRequireDefault(require("./modules/classes"));

var _symbols = _interopRequireDefault(require("./modules/symbols"));

var _editorTypes = require("./modules/editor-types");

Object.keys(_editorTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _editorTypes[key]) return;
  exports[key] = _editorTypes[key];
});

var _skeletonTypes = require("./modules/skeleton-types");

Object.keys(_skeletonTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _skeletonTypes[key]) return;
  exports[key] = _skeletonTypes[key];
});

var _designerTypes = require("./modules/designer-types");

Object.keys(_designerTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _designerTypes[key]) return;
  exports[key] = _designerTypes[key];
});

var _lowcodeTypes = require("./modules/lowcode-types");

Object.keys(_lowcodeTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _lowcodeTypes[key]) return;
  exports[key] = _lowcodeTypes[key];
});

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

(0, _lowcodeEditorSkeleton.registerDefaults)();
var editor = new _lowcodeEditorCore.Editor();

_lowcodeEditorCore.globalContext.register(editor, _lowcodeEditorCore.Editor);

_lowcodeEditorCore.globalContext.register(editor, 'editor');

var innerSkeleton = new _lowcodeEditorSkeleton.Skeleton(editor);
editor.set(_lowcodeShell.Skeleton, innerSkeleton);
editor.set('skeleton', innerSkeleton);

_lowcodeEditorCore.engineConfig.set('skeleton', innerSkeleton);

var designer = new _lowcodeDesigner.Designer({
  editor: editor
});
editor.set(_lowcodeDesigner.Designer, designer);
editor.set('designer', designer);

_lowcodeEditorCore.engineConfig.set('designer', designer);

var plugins = new _lowcodeDesigner.LowCodePluginManager(editor).toProxy();
exports.plugins = plugins;
editor.set('plugins', plugins);
var innerProject = designer.project;
var skeletonCabin = (0, _skeletonCabin["default"])(innerSkeleton);
var Workbench = skeletonCabin.Workbench;
var hotkey = new _lowcodeShell.Hotkey();
exports.hotkey = hotkey;
var project = new _lowcodeShell.Project(innerProject);
exports.project = project;
var skeleton = new _lowcodeShell.Skeleton(innerSkeleton);
exports.skeleton = skeleton;
var setters = new _lowcodeShell.Setters();
exports.setters = setters;
var material = new _lowcodeShell.Material(editor);
exports.material = material;
var config = _lowcodeEditorCore.engineConfig;
exports.config = config;
var event = new _lowcodeShell.Event(editor, {
  prefix: 'common'
});
exports.editor = exports.event = event;
var logger = (0, _lowcodeUtils.getLogger)({
  level: 'warn',
  bizName: 'common'
});
exports.logger = logger;
var designerCabin = (0, _designerCabin["default"])(editor);
var objects = {
  TransformStage: _lowcodeDesigner.TransformStage
};
var common = {
  utils: _utils["default"],
  objects: objects,
  editorCabin: editorCabin,
  designerCabin: designerCabin,
  skeletonCabin: skeletonCabin
};
exports.common = common;
// declare this is open-source version
var isOpenSource = true;
exports.isOpenSource = isOpenSource;
var __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = {
  symbols: _symbols["default"],
  classes: _classes["default"]
}; // 注册一批内置插件

exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
(function () {
  var _registerPlugins = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var componentMetaParser, setterRegistry, defaultPanelRegistry;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // 处理 editor.set('assets')，将组件元数据创建好
            componentMetaParser = function componentMetaParser(ctx) {
              return {
                init: function init() {
                  editor.onGot('assets', function (assets) {
                    var _assets$components = assets.components,
                        components = _assets$components === void 0 ? [] : _assets$components;
                    designer.buildComponentMetasMap(components);
                  });
                }
              };
            };

            componentMetaParser.pluginName = '___component_meta_parser___';
            _context.next = 4;
            return plugins.register(componentMetaParser);

          case 4:
            // 注册默认的 setters
            setterRegistry = function setterRegistry(ctx) {
              return {
                init: function init() {
                  var _require;

                  if (_lowcodeEditorCore.engineConfig.get('disableDefaultSetters')) return;
                  var builtinSetters = (_require = require('@alilc/lowcode-engine-ext')) === null || _require === void 0 ? void 0 : _require.setters;

                  if (builtinSetters) {
                    ctx.setters.registerSetter(builtinSetters);
                  }
                }
              };
            };

            setterRegistry.pluginName = '___setter_registry___';
            _context.next = 8;
            return plugins.register(setterRegistry);

          case 8:
            // 注册默认的面板
            defaultPanelRegistry = function defaultPanelRegistry(ctx) {
              return {
                init: function init() {
                  var _editor$getPreference;

                  skeleton.add({
                    area: 'mainArea',
                    name: 'designer',
                    type: 'Widget',
                    content: _lowcodePluginDesigner["default"]
                  });

                  if (!_lowcodeEditorCore.engineConfig.get('disableDefaultSettingPanel')) {
                    skeleton.add({
                      area: 'rightArea',
                      name: 'settingsPane',
                      type: 'Panel',
                      content: _lowcodeEditorSkeleton.SettingsPrimaryPane,
                      props: {
                        ignoreRoot: true
                      }
                    });
                  } // by default in float area;


                  var isInFloatArea = true;
                  var hasPreferenceForOutline = editor === null || editor === void 0 ? void 0 : (_editor$getPreference = editor.getPreference()) === null || _editor$getPreference === void 0 ? void 0 : _editor$getPreference.contains('outline-pane-pinned-status-isFloat', 'skeleton');

                  if (hasPreferenceForOutline) {
                    var _editor$getPreference2;

                    isInFloatArea = editor === null || editor === void 0 ? void 0 : (_editor$getPreference2 = editor.getPreference()) === null || _editor$getPreference2 === void 0 ? void 0 : _editor$getPreference2.get('outline-pane-pinned-status-isFloat', 'skeleton');
                  }

                  skeleton.add({
                    area: 'leftArea',
                    name: 'outlinePane',
                    type: 'PanelDock',
                    content: _lowcodePluginOutlinePane["default"],
                    panelProps: (0, _extends2["default"])({
                      area: isInFloatArea ? 'leftFloatArea' : 'leftFixedArea',
                      keepVisibleWhileDragging: true
                    }, _lowcodeEditorCore.engineConfig.get('defaultOutlinePaneProps'))
                  });
                  skeleton.add({
                    area: 'rightArea',
                    name: 'backupOutline',
                    type: 'Panel',
                    props: {
                      condition: function condition() {
                        return designer.dragon.dragging && !(0, _lowcodePluginOutlinePane.getTreeMaster)(designer).hasVisibleTreeBoard();
                      }
                    },
                    content: _lowcodePluginOutlinePane.OutlineBackupPane
                  });
                }
              };
            };

            defaultPanelRegistry.pluginName = '___default_panel___';
            _context.next = 12;
            return plugins.register(defaultPanelRegistry);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  function registerPlugins() {
    return _registerPlugins.apply(this, arguments);
  }

  return registerPlugins;
})()();
var engineInited = false; // @ts-ignore webpack Define variable

var version = VERSION_PLACEHOLDER;
exports.version = version;

_lowcodeEditorCore.engineConfig.set('ENGINE_VERSION', version);

function init(_x, _x2, _x3) {
  return _init.apply(this, arguments);
}

function _init() {
  _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(container, options, pluginPreference) {
    var engineOptions, engineContainer;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!engineInited) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt("return");

          case 2:
            engineInited = true;
            engineOptions = null;
            engineContainer = null;

            if ((0, _lowcodeUtils.isPlainObject)(container)) {
              engineOptions = container;
              engineContainer = document.createElement('div');
              document.body.appendChild(engineContainer);
            } else {
              engineOptions = options;
              engineContainer = container;

              if (!container) {
                engineContainer = document.createElement('div');
                document.body.appendChild(engineContainer);
              }
            }

            engineContainer.id = 'engine';

            _lowcodeEditorCore.engineConfig.setEngineOptions(engineOptions);

            _context2.next = 10;
            return plugins.init(pluginPreference);

          case 10:
            (0, _reactDom.render)( /*#__PURE__*/(0, _react.createElement)(Workbench, {
              skeleton: innerSkeleton,
              className: 'engine-main',
              topAreaItemClassName: 'engine-actionitem'
            }), engineContainer);

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _init.apply(this, arguments);
}